import { ValidationError } from 'pretur.validation';
import { Action, Dispatch } from 'reducible-node';
import { Clay, State } from './clay';
export declare class Value<T> implements Clay<Value<T>> {
    readonly identifier: symbol;
    readonly original: this;
    readonly state: State;
    readonly value: T;
    readonly error: ValidationError;
    constructor(value: T, error?: ValidationError, state?: State, original?: Value<T>, identifier?: symbol);
    readonly modified: boolean;
    readonly valid: boolean;
    reduce(action: Action<any>): this;
    clear(dispatch: Dispatch): void;
    replace(dispatch: Dispatch, by: this): void;
    setValue(dispatch: Dispatch, value: T, resetError?: boolean): void;
    setError(dispatch: Dispatch, error: ValidationError): void;
    setState(dispatch: Dispatch, state: State): void;
}
