import { HomingActionDefinition } from 'reducible-node';
import { Query, Filter, QueryPagination, QueryOrder } from 'pretur.sync';
import { ValidationError } from 'pretur.validation';
import { State } from './clay';
import { Record } from './Record';
export interface SetValuePayload {
    value: any;
    resetError: boolean;
}
export interface SetFieldPayload {
    field: string;
    value: any;
}
export interface SetFiltersPayload {
    filters: Filter<any> | undefined;
    path?: string[];
}
export interface SetExtraPayload {
    extra: any;
    resetPagination: boolean;
}
export interface RefreshPayload {
    data: any;
    count: any;
}
export declare const CLAY_CLEAR: HomingActionDefinition;
export declare const CLAY_REPLACE: HomingActionDefinition<any>;
export declare const CLAY_SET_VALUE: HomingActionDefinition<SetValuePayload>;
export declare const CLAY_SET_ERROR: HomingActionDefinition<ValidationError>;
export declare const CLAY_SET_STATE: HomingActionDefinition<State>;
export declare const CLAY_SET_REMOVED_AND_RESET: HomingActionDefinition<void>;
export declare const CLAY_SET_FIELD: HomingActionDefinition<SetFieldPayload>;
export declare const CLAY_ADD: HomingActionDefinition<Record<any>>;
export declare const CLAY_REMOVE: HomingActionDefinition<symbol>;
export declare const CLAY_REFRESH: HomingActionDefinition<RefreshPayload>;
export declare const CLAY_SET_QUERY_ATTRIBUTES: HomingActionDefinition<string[]>;
export declare const CLAY_SET_QUERY_FILTERS: HomingActionDefinition<SetFiltersPayload>;
export declare const CLAY_SET_QUERY_PAGINATION: HomingActionDefinition<QueryPagination>;
export declare const CLAY_SET_QUERY_ORDER: HomingActionDefinition<QueryOrder>;
export declare const CLAY_SET_QUERY_EXTRA: HomingActionDefinition<SetExtraPayload>;
export declare const CLAY_SET_QUERIEIR_COUNT: HomingActionDefinition<number>;
export declare const CLAY_RESET_QUERIEIR: HomingActionDefinition<Query<any>>;
